//Datei mit lcd-routinen
#include"mylcd16x2.h"
#include "delay.c"

#define nop() asm volatile ("nop")


void lcd_send_nibble( byte n )
{	


        outp(n<<4, PORTC);
        		
           nop();
	sbi(PORTC, 2);	//Enable = 1
           nop();
           nop();
           nop();
        cbi(PORTC, 2);	//Enable =0
           nop();



}

void lcd_send_byte( byte address, byte n )
{

	DDRC = 0xff;
	
	cbi(PORTC, 1);	//RW = 0
	 
	if(address)
	   sbi(PORTC,0);	//RS = 1 ->Daten schreiben
	 else  
	   cbi(PORTC,0);	//RS = 0 ->Kommando senden
 
     
  

	//Daten senden
	wait_busy();
	lcd_send_nibble(n >> 4);
	wait_busy();
	lcd_send_nibble(n & 0x0f);
     
}


void lcd_init(void)
{

    byte i;

    outp(0xff, DDRC);
    
   //RS, RW auf 0,E auf 0
    cbi(PORTC, 0);               // siehe 4-Bit Initialisierung (LCD-Datenblatt)
    cbi(PORTC, 1);
    cbi(PORTC, 2);


	//Lnger als 15ms warten
	delay10(18000); 

	//3mal 3 senden
    for(i=0;i<3;i++)
    {
       lcd_send_nibble(3);      
       if(i==0 || i == 1)
           delay10(wait[i]);
       
       else 
          delay10(wait[i]);
       
    }
 
 
	lcd_send_nibble(2);
	delay10(2);

	//Funktionset
	//Display an
	//Display lschen
	//Entry mode set
    for(i=0; i <= 3; i++)
    {
       lcd_send_command(LCD_INIT_STRING[i]);

    }  
}


void lcd_gotoxy(byte x, byte y) 		// goto position (x, y)  MAX y = 1
{
	static	u08 lcd_line[] = {0x00, 0x40};


	lcd_send_command((1 << LCD_DDRAM) + lcd_line[y] + x);
}


void lcd_putc(char f)
{
	lcd_send_data(f); 
}


void lcd_send_command(byte cmd)
{
	lcd_send_byte(0, cmd);
}

void lcd_send_data(byte data)
{
	lcd_send_byte(1, data);
}	


void wait_busy()
{
      register byte data;

	cbi(PORTC,0);	//RS = 0
      sbi(PORTC, 1);	//  RW = 1 //lesen
   //   sbi(PORTC, 2);	//E = 1 (HIGH)
      outp(0x0f, DDRC);	//BIT 7-4 als Input
	
	do
	{
		sbi(PORTC, 2);	//Enable = 1
		nop();
     		data = inp(PINC);		
      		cbi(PORTC, 2);	//Enable = 0
      
	}while(data & 0x80);
	
	//Standards Wiederherstellen
	outp(0xff, DDRC); //Port C wieder Ausgang
	cbi(PORTC,1);	//RW wieder 0

}


void Return_Home(void)
{

	lcd_send_command(1);
}
